<?
include("data/mpg5_14.php");



/******************************************************************/
//              BASICS VARIABLES
/******************************************************************/
$error="";
$graph[][]="";
$v=0;$v1=0;$v2=0;

/*
    v1
N       v
    v2
*/

//----------------------------------------------------------//
// Nv : first neighborhood of current vertex v to explose   //
// Nv1 : first neighborhood of v after explosion            //
// Nv2 : first neighborhood of N+1 after explosion          //
//----------------------------------------------------------//
$Nv[]="";$Nv1="";$Nv2[]="";

/******************************************************************/
//              INIT GRAPH
/******************************************************************/


function init_graph ($starting_graph){
    global $N, $degree,$graph;
    
    for ($i=1;$i<=$N;$i++){
        $dg=$degree[$i];
        for($j=1;$j<=$degree[$i];$j++)
            $graph[$i][$j]=$starting_graph[$i][$j];
        }
    return $graph;
    }

/******************************************************************/
//              VERTICES   SELECTION
/******************************************************************/

function vertex_selection (){
    global $X_sup6, $card_X_sup6, $N, $degree,$v, $verbose;
    $card_X_sup6=0;
    $j=1; 
    for($i=1;$i<=$N;$i++) {
        if ($degree[$i]>5) {
            $card_X_sup6++;
            $X_sup6[$j]=$i;
            if ($verbose=="ok") print " j=$j ";
            $j++;
            }
        }
    $pos=rand (1,$card_X_sup6);
    $v= $X_sup6[$pos];
    if ($verbose=="ok") print "<br>vertex_selection::: card_X_sup6=$card_X_sup6 pos=$pos X_sup6[$pos]=$X_sup6[$pos] v=$v";
    }

/*****************************/
function vertex_selection_v1 ($v){
    global $X_sup6, $card_X_sup6, $graph, $degree;
    $pos=rand (1,$degree[$v]-3);
    return ($pos);
    }

/*****************************/
function vertex_selection_v2 ($v,$pos1){
    global $X_sup6, $card_X_sup6, $graph, $degree;
    
    $start=$pos1+3;$end=(($pos1-3)%($degree[$v]))+$degree[$v];
    if ($end>$degree[$v]) $end=$degree[$v];
    if ($start<$end) $pos=rand ($pos1+3,$end);else  $pos=$start;
    return ($pos);
    }   

/******************************************************************/
//               NEIGHBORHOOD DISPATCHING
/******************************************************************/

function cp_neighborhood($v){
    global $graph, $degree;
    for($i=1;$i<=$degree[$v];$i++)
        $Nv[$i]=$graph[$v][$i];
    return $Nv;
    }

/************************************/
// about Nv and Nn+1
/************************************/

function maj_Nv_and_Nn ($v,$pos1,$pos2){
    global $graph, $degree, $N, $Nv1, $Nv2;
    
    $Nv = cp_neighborhood($v);
    for($i=0;$i<=$N+1;$i++){$Nv1[$i]="";$Nv2[$i]="";} // INIT
    $j1=1;for($i=$pos1;$i<=$pos2;$i++) {$Nv1[$j1]=$Nv[$i];$j1++;}
    $j2=1;for($i=$pos2;$i<=$degree[$v];$i++) {$Nv2[$j2]=$Nv[$i];$j2++;}
    for($i=1;$i<=$pos1;$i++) {$Nv2[$j2]=$Nv[$i];$j2++;}
    
    $Nv1[$j1]=$N+1;
    $Nv2[$j2]=$v;
    }

function maj_vertex($v,$Nvi){
    global $graph,$degree,$N, $verbose;
    
    $i=1;
    if ($verbose=="ok") print "<br>maj_vertex($v,$Nvi)<br>";
    while($Nvi[$i]!=""){
        $graph[$v][$i]=$Nvi[$i];
        if ($verbose=="ok"){print " graph[$v][$i]=$Nvi[$i] ";}
        $i++;
        }
    $degree[$v]=$i-1;
    // matrix cleaning 
    for($i=$degree[$v]+1;$i<=$N;$i++){
        $graph[$v][$i]="";
        if ($verbose=="ok"){$tmp=$graph[$v][$i];print " (v) graph[$v][$i]=$tmp ";}
        }
    if ($verbose=="ok") print "<br>FIN maj_vertex($v,$Nvi)<br>";
    }
    
function maj_neighborhood(){
    global $graph, $degree, $Nv2, $N, $v, $v1, $v2, $verbose;
    
    $dg=$degree[$N+1];
    $i=1;
    while ($Nv2[$i]!=""){
        $j=$Nv2[$i];
        if (($j!=$v1) && ($j!=$v2)){
            for($k=1;$k<=$degree[$j];$k++){
                $vois = $graph[$j][$k];
                if ($graph[$j][$k]==$v){ 
                    $graph[$j][$k]=$N+1;$k=$degree[$j]+2;
                    if ($verbose=="ok") print " ECHANGE ... autour de $j du sommet $v en $N+1 ";
                    }
                }
            }
        $i++;
        }
    }   
    
function maj_graph($v){
    global $graph, $Nv1,$Nv2, $N;
    
    maj_vertex($v,$Nv1);
    maj_vertex($N+1,$Nv2);
    maj_neighborhood();
    }
    
/************************************/
// about Nv1 and Nv2
/************************************/


function local_update_v1_v2 ($v,$v1_or_v2,$its_v1){
    global $degree,$graph,$N;
    
    $t=1;
    for($j=1;$j<=$degree[$v1_or_v2];$j++){
        $Na[$t]=$graph[$v1_or_v2][$j];
        if (($Na[$t]==$v)&&($its_v1=="yes"))
            {$t++;$Na[$t]=$N;}
        if (($Na[$t]==$v)&&($its_v1=="no"))
            {$Na[$t]=$N;$t++;$Na[$t]=$v;}
        $t++;
        }
    $degree[$v1_or_v2]++;
    for($j=1;$j<=$degree[$v1_or_v2];$j++) $graph[$v1_or_v2][$j]=$Na[$j];
}   
    
/******************************************************************/
//              VERIFICATION valid plan orientation
/******************************************************************/

function local_verif($x,$y,$z,$v,$a,$b){
    // around x we looking for the sequence y and z
    global $graph, $degree, $error, $N;
    
    for($i=1;$i<=$degree[$x];$i++){
        if ($graph[$x][$i]==$y){
            $k=$i+1;
            if ($k>$degree[$x])  $k=1;
            $proba_z=$graph[$x][$k];
            if ($proba_z!=$z) {
                print "<br> Bad orientation N=$N: init (v=$v,a=$a,b=$b) around x=$x we looking for the sequence y=$y and z=$z !!!<br>";
                $error=-1;
                }
            }
        }
        
    }
    
function verification (){
    global $graph, $degree,$N,$error;
    
    for ($v=1;$v<=$N;$v++){
        for ($i=1;$i<$degree[$v];$i++){
            $a=$graph[$v][$i];
            $b=$graph[$v][$i+1];
            // v give a and b. So 1) a should give b and v 2) b should give v and a. => verification
            local_verif($a,$b,$v,$v,$a,$b); local_verif($b,$v,$a,$v,$a,$b);
            }
        if ((!$error) && ($verbose=="ok")) print "<br>Verication around v=$v OK...";
        }
    if ($error<0) {
        display_graph();
        print "<br> Verification Failed...<br>";
        }
    else
        print "<br> Verification OK... N=$N<br>";
    }


/******************************************************************/
//              DIMACS GRAPH
/******************************************************************/

function dimacs_url ($url){
    global $graph, $degree, $N, $error;
    
    if ($url==""){
        return;
        }
     verification ();
     if ($error<0)  {
        print "<br>Error problem<br> No DIMACS graph created.<br>";
        exit();
        }
     $fp = fopen($url, "w");
     if (!$fp) {
        print "<br>File system access not authorized for $url.";
        exit();
        }
     fwrite($fp, "c FILE: MPG5 generator\n");
     fwrite($fp, "c SOURCE: Philippe Rolland-Balzon (prolland@sepro-robotique.com)\n");
     fwrite($fp, "c DESCRIPTION: Graph based on explosion transformation. \n");
     fwrite($fp, "c              Maximal Planar Graph with minimum degree five. \n");
     fwrite($fp, "p edge $N ? \n");
     for($i=1;$i<=$N;$i++){
        for($j=1;$j<=$degree[$i];$j++){
            $val=$graph[$i][$j];
            fwrite($fp, "e $i $val\n");
            }
        }
     fclose($fp);
    }

function dimacs_display (){
    global $graph, $degree, $N, $error;
    

     verification ();
     if ($error<0)  {
        print "<br>Error problem<br> No DIMACS graph created.<br>";
        exit();
        }

     print "c FILE: MPG5 generator<br>";
     print "c SOURCE: Philippe Rolland-Balzon (prolland@sepro-robotique.com)<br>";
     print "c DESCRIPTION: Graph based on explosion transformation. <br>";
     print "c              Maximal Planar Graph with minimum degree five. <br>";
     print "p edge $N ? <br>";
     for($i=1;$i<=$N;$i++){
        for($j=1;$j<=$degree[$i];$j++){
            $val=$graph[$i][$j];
            print "e $i $val<br>";
            }
        }
    }
        
/******************************************************************/
//              DISPLAY
/******************************************************************/

function display_graph (){
    global $graph, $degree, $N;
    print "\n<br><br>Graph Display(N=$N)<br>\n";
    for($i=1;$i<=$N;$i++){
        print "\n<br>$i ($degree[$i]) : ";
        for ($j=1;$j<=$degree[$i];$j++){
            $n=$graph[$i][$j];
            print " $n ";
            }
        }
    print"\n<br>";  
    }
    
function display_vecteur($title,$vect,$lg){
    global $degree;
    print "\n<br>Vecteur $title:<br>\n";
    if ($lg<=0)  $lg = sizeof($vect);
    for($i=1;$i<=$lg;$i++){
        $dg=$degree[$vect[$i]];
        print "\n value[$i]=$vect[$i] dg=$dg<br>";
        }
    print"\n<br>";  
    }

function time_delta ($delta){
    print "\n<br>Time:$delta(s)<br>\n";
    }   
/******************************************************************/
//              FLIP
/******************************************************************/

function flip (){
    global $graph, $degree;
}


/******************************************************************/
//              MAIN
/******************************************************************/


error_reporting (0);
$deb =time();
$graph = init_graph ($MPG14);
if ($verbose=="ok") display_graph();    

while ($N<$Nmax){
    if ($verif_all=="ok") verification();
    vertex_selection();
    
    if ($verbose == "ok") display_graph();
    if ($verbose == "ok") display_vecteur("Xsup6 ",$X_sup6,$card_X_sup6);
    
    

    $pos1 = vertex_selection_v1($v);
    $pos2 = vertex_selection_v2 ($v,$pos1);

    $v1=$graph[$v][$pos1];
    $v2=$graph[$v][$pos2];
    if ($selected == "ok") print "<br> Selected N=$N (before) vertices v=$v dg($v)=$degree[$v]: neighbors v1=$v1(pos=$pos1) v2=$v2(pos=$pos2)<br>";

    maj_Nv_and_Nn($v,$pos1,$pos2);
    maj_graph($v);
    $N++;


    local_update_v1_v2($v,$v1,"yes"); // We looking for $v around $v1; and place a new neighborhord $N after
    local_update_v1_v2($v,$v2,"no"); // We looking for $v around $v2; and replace $v by new neighborhord $N and place $v after
    }
$fin = time();$delta=$fin-$deb;

verification();
if ($matrix=="ok") display_graph();
if ($verif=="ok") verification();
if ($dimacs=="ok") dimacs_display ();
if ($time=="ok") print "\n<br>Time:$delta(s)<br>\n";
dimacs_url ($url,"");


?>
