<?


/******************************************************************/
//              FLIP : DIAGONAL TRANSFORMATION
/******************************************************************/

/*
    c
a<------>b
    d

*/

$a=0;$b=0;$c=0;$d=0; // four vertices in order to use diagonal operation


function find_c_d_for_D (){
    global $graph, $degree ,$a,$b,$c,$d;

    for($i=1;$i<=$degree[$a];$i++){
        if ($graph[$a][$i]==$b){
            switch ($i){
                case 1:
                    $c=$graph[$a][$degree[$a]];
                    $d=$graph[$a][2];
                    break;
                case $degree[$a]:
                    $c=$graph[$a][$i-1];
                    $d=$graph[$a][1];
                    break;
                default:
                    $c=$graph[$a][$i-1];
                    $d=$graph[$a][$i+1];
                }
            }
        }
    }

/************************************/
// Update neighbors around x1 (either c, d)
// looking for sequence y, z around x1
// and add edge between x1 and x2: ie
// let (x1,x2,y,z) we have :
// (c,d,b,a) and (d,c,a,b)
/************************************/

function insert_edge_around_c_d ($x1,$x2,$y,$z){
    global $graph,$degree;

    $j=1;
    for ($i=1;$i<=$degree[$x1];$i++){
        $tmp[$j]=$graph[$x1][$i];
        if ($graph[$x1][$i]==$y){
            $j++;
            $tmp[$j]=$x2;
            }
        $j++;
        }
    $degree[$x1]++;
    for ($i=1;$i<=$degree[$x1];$i++) $graph[$x1][$i]= $tmp[$i];
}

/************************************/
// Update neighbors around x1 (either a, b)
// looking for sequence y, x2, z around x1
// and remove edge between x1 and x2: ie
// let (x1,x2,y,z) we have :
// (a,b,c,d) and (b,a,d,c)
/************************************/

function remove_edge_around_a_b ($x1,$x2,$y,$z){
    global $graph,$degree;

    $j=1;
    for ($i=1;$i<=$degree[$x1];$i++){
        $tmp[$j]=$graph[$x1][$i];
        if ($graph[$x1][$i]==$x2){
            $j--;
            }
        $j++;
        }
    $degree[$x1]--;
    for ($i=1;$i<=$degree[$x1];$i++) $graph[$x1][$i]= $tmp[$i];
}

function flip_select_ab (){
    global $MAX_TRY_D, $graph, $degree , $X_sup6, $card_X_sup6, $a ,$b ,$verbose;

    $try=0;$rank=0;
    while (($try<=$MAX_TRY_D)&&($rank==0)){
        $pos=rand (1,$card_X_sup6);
        $a_potential = $X_sup6[$pos];
        if ($degree[$a_potential]<=5){
            print "<br>Error in flip_select_ab (try=$try and max=$MAX_TRY_D)";
            display_vecteur("Xsup6 vector Error",$X_sup6,$card_X_sup6);
            display_graph();
            }
        $j=0;
        for ($i=1;$i<=$degree[$a_potential];$i++)
            if ($degree[$graph[$a_potential][$i]]>=6){$j++;$tmp[$j]=$graph[$a_potential][$i];}
        if ($j>0){
            $a=$a_potential;
            $rank=rand (1,$j);// at random we have choosing a neighbord in Xsup6
            $b = $tmp[$rank];
            }
        if (($verbose=="ok")&&($rank==0)) print "<br>FCT flip_select_ab no Xsup6 around $a_potential (try=$try and max=$MAX_TRY_D)\n";
        $try++;
        }
}


function flip(){
    global $a,$b,$c,$d, $N, $degree ,$MAX_TRY_D, $verif_all, $verbose;

    $try=0;$c_d_neighbord=TRUE;
    while (($try<=$MAX_TRY_D)&&($c_d_neighbord==TRUE)){
        flip_select_ab ();
        find_c_d_for_D ();
        $c_d_neighbord = neighbord($c,$d);$try++;
        if (($verbose=="ok")&&($c_d_neighbord==TRUE))  print "<br> FCT=flip Diagonal Operation (N=$N) :a=$a($degree[$a]), b=$b($degree[$b]), c=$c($degree[$c]) and d=$d($degree[$d]). BUT ($c -- $d)<br>";
        }
    if ($c_d_neighbord==FALSE){
        $old_dg_c = $degree[$c]; $old_dg_d = $degree[$d];
        if ($verbose=="ok")  print "<br> FCT=flip Diagonal Operation (N=$N) : a=$a($degree[$a]), b=$b($degree[$b]), c=$c($degree[$c]) and d=$d($degree[$d]).<br>";
        insert_edge_around_c_d ($c,$d,$b,$a);
        insert_edge_around_c_d ($d,$c,$a,$b);

        remove_edge_around_a_b ($a,$b,$c,$d);
        remove_edge_around_a_b ($b,$a,$d,$c);

        Xsup6_add_vertex($c,$old_dg_c);Xsup6_add_vertex($d,$old_dg_d);
        Xsup6_del_vertex($a);Xsup6_del_vertex($b);

        if ($verif_all=="ok") verification();
        }
}


function flip2 ($i,$j){
    global $a,$b,$c,$d, $N, $degree ,$MAX_TRY_D, $verif_all, $verbose;

    $try=0;$c_d_neighbord=TRUE;$a=$i;$b=$j;
    while (($try<=$MAX_TRY_D)&&($c_d_neighbord==TRUE)){
        find_c_d_for_D ();
        $c_d_neighbord = neighbord($c,$d);$try++;
        if (($verbose=="ok")&&($c_d_neighbord==TRUE))  print "<br> FCT=flip Diagonal Operation (N=$N) :a=$a($degree[$a]), b=$b($degree[$b]), c=$c($degree[$c]) and d=$d($degree[$d]). BUT ($c -- $d)<br>";
        }
    if ($c_d_neighbord==FALSE){
        $old_dg_c = $degree[$c]; $old_dg_d = $degree[$d];
        if ($verbose=="ok")  print "<br> FCT=flip Diagonal Operation (N=$N) : a=$a($degree[$a]), b=$b($degree[$b]), c=$c($degree[$c]) and d=$d($degree[$d]).<br>";
        insert_edge_around_c_d ($c,$d,$b,$a);
        insert_edge_around_c_d ($d,$c,$a,$b);

        remove_edge_around_a_b ($a,$b,$c,$d);
        remove_edge_around_a_b ($b,$a,$d,$c);

        Xsup6_add_vertex($c,$old_dg_c);Xsup6_add_vertex($d,$old_dg_d);
        Xsup6_del_vertex($a);Xsup6_del_vertex($b);

        if ($verif_all=="ok") verification();
        }
}


function flips(){
    global $flip, $N, $max_d, $verbose, $nbflip;
    if (($flip == "ok")&&($N>16)) {
        $nbD = rand(1,$max_d);
        for ($l=1;$l<=$nbD;$l++) {
            flip();
            if ($verbose=="ok") display_graph();
            }
        }
    $nbflip[$N]=$nbD;
}

?>
